/******************************************************************************

* File Name : DerefBF.js

* Purpose : Strengthen browser with bloom filter

* Creation Date : 21-11-2010

* Last Modified : Friday, July 22, 2011 PM12:29:48 HKT

*******************************************************************************/
if(!deref) var deref={};
deref.start =function(){
  oDerefBFEnforcer = new derefBFEnforcer();
  deref.addToListener(oDerefBFEnforcer);
}
deref.stop = function(){
  deref.removeFromListener(oDerefBFEnforcer)
}
//Start venkman code
deref.Debug = function(){
	start_venkman();
}
function toOpenWindowByType(inType, uri) {
  var winopts = "chrome,extrachrome,menubar,resizable,scrollbars,status,toolbar";
  window.open(uri, "_blank", winopts);
}
//End venkman code
deref.addToListener = function(obj){
    var observerService = Components.classes["@mozilla.org/observer-service;1"].
                              getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(obj, "http-on-modify-request", false);
    observerService.addObserver(obj, "http-on-examine-response", false);
}
deref.removeFromListener = function(obj)
{
    var observerService = Components.classes["@mozilla.org/observer-service;1"].
                              getService(Components.interfaces.nsIObserverService);
    observerService.removeObserver(obj, "http-on-modify-request");
    observerService.removeObserver(obj, "http-on-examine-response");
}
oDerefLogger = null;
derefBFEnforcer = function(){
     oDerefLogger = new derefLogger("BF Enforcer",NORMAL);
     this.logger = oDerefLogger;
     this.exception = "\"\"";
     setTimeout("oDerefLogger.Flush();",100);
	this.hash = new Object();
	this.useCache = true;
	this.setCache();
//For Demonstration Purpose
/*
	this.logger.Log("Prefix "+DerefConfig.prefixURL);
	this.logger.Log("Initiating "+DerefConfig.initiatingURL);
	this.logger.Log("Target "+DerefConfig.targetURL);
	var initBF = new BloomFilter(1024);
	initBF.Add(DerefConfig.initiatingURL);
	var targetBF = new BloomFilter(1024);
	targetBF.Add(DerefConfig.targetURL);
	var filters = new Array();
	filters.push(targetBF);
	filters.push(initBF);
	this.add(DerefConfig.prefixURL,filters);
	this.displayed = false;
*/
//End of code block
}
var t0,t1,t2,t3;
derefBFEnforcer.prototype = {
     //The function to be call when the brwoser receive/send HTTP message
     observe: function(aSubject, aTopic, aData){
	if(aTopic == 'http-on-modify-request'){
		aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
		//Exclude signing request
		//Use fragment ID
		if(aSubject.originalURI.path.search("sign") == -1){
			this.logger.Log("aSubject Request"+aSubject.originalURI.path);
			this.onModifyRequest(aSubject);
		}
	}
	if(aTopic == 'http-on-examine-response'){
		aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
		//Exclude signing request
		if(aSubject.originalURI.path.search("sign") == -1){
			this.logger.Log("aSubject Response"+aSubject.originalURI.path);
			this.onExamineResponse(aSubject);
		}
	}
     },
	onExamineResponse: function(oHttp){
		var cookies;
		var key;
		var header=undefined;
		try{
			cookies = oHttp.getResponseHeader("Set-Cookie").split("\n");
		}catch(e){}
		if(cookies == undefined){
			this.logger.Log("===============================================");
			return;
		}
		try{
			header = oHttp.getResponseHeader("Protection-Filters");
		}catch(e){}
this.logger.Log("Header: "+header);
		if(header != undefined){
			domain = header.split(";")[0].split("=")[1].split("/")[0];
			path = "/"+header.split(";")[0].split("=")[1].split("/")[1]+"/";
			key = domain + path;
			var scheme = "http://";//TODO
			if(!this.isSet(key)){
				var filters = this.downloadFilter(scheme+domain+path);
				this.add(key,filters);
			}
		}else{
			key = this.longestMatch(oHttp.originalURI.spec);
		}
this.logger.Log("origin: "+oHttp.originalURI.spec);
this.logger.Log("Key: "+key);
		if(this.isSet(key)){
			var tabDocument = this.getTabDocument(oHttp);
			var tree = this.createiFrameTree(tabDocument);
			var urls= this.collectInitiatingURLs(tree);
			urls[tabDocument.location.href]= tabDocument.location.href;
			if(oHttp.referrer!=null)
				urls[oHttp.referrer.spec] = oHttp.referrer.spec;
		t1 = new Date().getTime();
			var checkingResult = this.checkingLogic(oHttp.originalURI.spec,urls,key);
			if((checkingResult["sensitive"])&&(!checkingResult["init"])){
				oHttp.setResponseHeader("Set-Cookie","",false);
				this.logger.Log("Response Detected");
			}
		}
		t3 = new Date().getTime();
//this.logger.Log("Hash Checking: "+(t2-t1));
//this.logger.Log("Blind Checking: "+(t3-t2));
//this.logger.Log("Response Time: "+(t3-t0));
this.mark("http://192.168.50.92/wordpress/");
		this.logger.Log("===============================================");
	},
	checkingLogic:function(target,init,key){
		var checkingResult =new Array();
		var cache = this.getFilters(key)[5];
		var sensitiveURL = this.isSensitivePage(target,this.getFilters(key)[0]);
		t2 = new Date().getTime();
		var cacheResult = undefined;
		if(sensitiveURL){
			var result = this.checkInitURLs(init,this.getFilters(key)[1]);
			t2 = new Date().getTime();
			if(this.useCache){
				var cacheSensitive = this.cacheSensitiveChecking(sensitiveURL,cache["sensitive"]);
				if(cacheSensitive == true){
					var cacheInit = this.cacheInitChecking(result,cache["init"]);
					checkingResult["sensitive"] = true;
					if(cacheInit == true){
						checkingResult["init"] = true;
						return checkingResult;
					}else if ((cacheInit == false)||(!result)){
						checkingResult["init"] = false;
						return checkingResult;
					}
				}else if(cacheSensitive==false){
					checkingResult["sensitive"] = false;
					checkingResult["init"] = true;
					return checkingResult;
				}
			}
			if(result)
				var signedURLs = this.getFilters(key)[4].main(sensitiveURL,result);
			else
				var signedURLs = this.getFilters(key)[4].main(sensitiveURL,new Array());
			checkingResult["sensitive"] = this.confirmSensitive(signedURLs["target"],
									    this.getFilters(key)[2],
									    cache["sensitive"]);
			checkingResult["init"] = this.confirmValid(signedURLs["init"],
								   this.getFilters(key)[3],
								   cache["init"]);
		}else{
			checkingResult["sensitive"] = false;
			checkingResult["init"] = true;
		}
		return checkingResult;
	},
	confirmSensitive: function(target,filter,cache){
		var result = false;
		for(var i in target){
		    if(filter[target[i]]){
			cache[i] = true;
			result = true;
		    }else
			cache[i] = false;
		}
		return result;
	},
	confirmValid: function(init,filter,cache){
		if(!init)
			return false;
		var individualResult = false;
		var finalResult = true;
		for(var i in init){
			var individualResult = false;
			for(var j in init[i]){
				if(filter[init[i][j]]){
					individualResult =true; 
					cache[j] = true;
				}else{
					cache[j] = false;
				}
			}
			finalResult = finalResult && individualResult;
		}
		return finalResult;
        },
	cacheSensitiveChecking: function(target,cache){
		var result = undefined;
		for(var i in target){
			if(cache[target[i]] == undefined)
				continue;
			else if((cache[target[i]] == false) && (result == undefined))
				result = false;
			else if(cache[target[i]] == true)
				result = true;
		}
		return result;
	},
	cacheInitChecking: function(init,cache){
		var finalResult = undefined;
		for(var i in init){
			var individualResult = undefined;
			for(var j in init[i]){
				if(cache[j] == undefined)
					continue;
				else if((cache[j] == false) && (individualResult == undefined))
					individualResult = false;
				else if(cache[j] == true)
					individualResult = true;
			}
			if(individualResult == undefined)
				return undefined;
			else if(individualResult == false)
				return false;
			else
				finalResult = true;
		}
		return finalResult;
	},
	downloadFilter: function(filterLocation,len){
		return this.downloadHashFilter(filterLocation,len);
		//return this.downloadBloomFilter(filterLocation);
	},
	mark: function(location){
		var request = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"].createInstance();
		request.open("GET", location+"mark_firefox.php?type="+(t2-t1)+" "+(t3-t2)+" "+(t3-t0),false);
		alert("NIMA");
		request.send(null);
	},
	downloadHashFilter: function(filterLocation,len){
		try {
			if(len == null)
				len = 4;
			var request = Components
						.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						.createInstance();
this.logger.Log("Info: "+filterLocation+"genFilters.php?len="+len);
			request.open("GET", filterLocation+"genFilters.php?len=0", false );
			request.send( null );
this.logger.Log("status: "+request.status);
			if( request.status == 200 ) {
				var results = new Array();
				var filters = JSON.parse(request.responseText);
				var sensitiveHF = new HashFilter(filters["len"]);
				var validScopeHF = new HashFilter(filters["len"]);
				sensitiveHF.ImportFilter(filters["sensitive"]);
				validScopeHF.ImportFilter(filters["validScope"]);
				results.push(sensitiveHF);
				results.push(validScopeHF);
				results.push(filters["sensitiveList"]);
				results.push(filters["validScopeList"]);
				results.push(new derefSigner(filterLocation,filters["publicKey"]));
				cache = new Object();
				cache["sensitive"] = new Object();
				cache["init"] = new Object();
				results.push(cache); 	//Cache
				return results;
			} else {
				this.logger.Log("Hash Filter not found");
			}
		} catch( e ) {
			this.logger.Log(e);
			this.logger.Log("Hash Filter not found");
		}
	},
	downloadBloomFilter: function(filterLocation){
		try {
			var request = Components
						.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
						.createInstance();
			request.open("GET", filterLocation+"genFilters.php", false );
			request.send( null );
			if( request.status == 200 ) {
				var results = new Array();
				var lines = request.responseText.split( "\n" );
				var cookie = lines[0];
				var salt = lines[1];
				var sensitive = lines[2];
				var valid = lines[3];
				this.logger.Log("cookie "+cookie);
				this.logger.Log("salt "+salt);
				this.logger.Log("sensitive "+sensitive);
				this.logger.Log("valid "+valid);
				var sensitiveBF = new BloomFilter(0);
				var validScopeBF = new BloomFilter(0);
				sensitiveBF.ImportBase64(sensitive,salt);
				validScopeBF.ImportBase64(valid,salt);
				results.push(sensitiveBF);
				results.push(validScopeBF);
				return results;
			} else {
				this.logger.Log("Bloom Filter not found");
			}
		} catch( e ) {
			this.logger.Log(e);
			this.logger.Log("Bloom Filter not found");
		}
	},
     onModifyRequest: function(oHttp){
t0 = new Date().getTime();
		var tabDocument = this.getTabDocument(oHttp);
		var tree = this.createiFrameTree(tabDocument);

		var urls= this.collectInitiatingURLs(tree);
		urls[tabDocument.location.href] = tabDocument.location.href;
		if(oHttp.referrer!=null)
			urls[oHttp.referrer.spec] = oHttp.referrer.spec;

		var key = this.longestMatch(oHttp.originalURI.spec);
		if(this.isSet(key)){
			var checkingResult = this.checkingLogic(oHttp.originalURI.spec,urls,key);
			if((checkingResult["sensitive"])&&(!checkingResult["init"])){
				oHttp.setRequestHeader("Cookie","",false);
				this.logger.Log("Detected");
			}
		}else{
			this.logger.Log("No configurations found");
		}
		this.logger.Log("===============================================");
	 },
	checkInitURLs:function(urls,bf){
		var result = new Array();
		for(url in urls){
			var validScope = this.isValidScope(urls[url],bf);
			if(!validScope)
				return false;
			else{
				result.push(validScope);
			};
		}
		return result;
	},
	incrementalMatch:function(url,filter){
		var protocol = url.substr(0,url.indexOf("/")+2);
		url = url.substr(url.indexOf("/")+2);
		var host = url.substr(0,url.indexOf("/"));
		var path =url.substr(url.indexOf("/"));
		path = path.split("/");
		currentHost = "";
		currentPath = "";
		host = host.split(".");
		var i = host.length-1;
		var result = new Object();
		var found = false;
		while(i>=0){
			currentHost = host[i] + currentHost;
			currentHost = (i>0)? "."+currentHost:currentHost;
			var j = 0;
			while(j<path.length){
				currentPath += (j==path.length-1)?path[j]:path[j]+"/";
				currentURL = protocol+currentHost+currentPath;
				//this.logger.Log("Enumberated URL"+currentURL);
				if(filter.Has(currentURL)){
					this.logger.Log("Found URL"+currentURL);
					result[currentURL] = currentURL;
					found = true;
				}
				j++;
			}
			currentPath = "";
			i--;
		}
		if(found)
			return result;
		else
			return false;
	},
	isValidScope: function(url,validScopeBF){
		var length = url.indexOf("?");
		url = (length > 0)?url.substr(0,length):url;
		this.logger.Log("Valid URL "+url);
		return this.incrementalMatch(url,validScopeBF);
		//return validScopeBF.Has(tabURL);
	},
	isSensitivePage: function(destinationURL,sensitiveBF){
		var length = destinationURL.indexOf("?");
		destinationURL = (length > 0)?destinationURL.substr(0,length)
								:destinationURL;
		this.logger.Log("Destionation URL "+destinationURL);
		return this.incrementalMatch(destinationURL,sensitiveBF);
		//return sensitiveBF.Has(destinationURL); Without incremental match
	},
     //Retrieve Tab document from the brwoser
	//Retrieve iframe src recursively
	//Reference https://developer.mozilla.org/en/XUL/iframe
	//For normal tabl
	//	domWin.window.document.getElementsByTagname("iframe")[0].contentDocument.getElementsbyTagName....
	//For first tab:
	//	currentBrowser.contentWindow.document
	//Initiating URLs
	//How about more than one iframe?
	createiFrameTree:function(document){
		var node = new Object();
		node.protocol = document.location.protocol;
		node.host= document.location.hostname;
		node.path= document.location.pathname;
		node.url = document.location.href;
		var iframes = document.getElementsByTagName("iframe");
		if(iframes.length >0){
			this.addChildren(node,iframes);
		}
		return node;
	},
	addChildren:function(parent,iframes){
		parent.children = new Array();
		for(var i = 0;i < iframes.length;i++){
			var node = new Object();
			node.protocol = iframes[i].contentDocument.location.protocl;
			node.host= iframes[i].contentDocument.location.hostname;
			node.path= iframes[i].contentDocument.location.pathname;
			node.url= iframes[i].contentDocument.location.href;
			node.parent = parent;
			if(iframes[i].contentDocument.getElementsByTagName("iframe").length > 0)
				this.addChildren(node,iframes[i].contentDocument.getElementsByTagName("iframe"));
			parent.children.push(node);
		}
	},
	collectInitiatingURLs:function(tree){
		var node = tree;
		var result = new Object();
		if(node.url != "about:blank")
			result[node.url] = node.url;
		for(var i = 0;node.children!=null&&i<node.children.length;i++){
			var tmpResult = this.collectInitiatingURLs(node.children[i]);
			for(url in tmpResult)
				result[url] = tmpResult[url];
		}
		return result;
	},
     getTabDocument: function (aChannel) {
          try {
               var notificationCallbacks = 
                    aChannel.notificationCallbacks ? aChannel.notificationCallbacks 
                                                   : aChannel.loadGroup.notificationCallbacks;
               if (!notificationCallbacks)
                    return null;
               var domWin = notificationCallbacks.
                              getInterface(Components.interfaces.nsIDOMWindow);
               return domWin.top.document;;
          }
          catch (e) {
               this.exception = e.name;
               return this.getFirstTabDocument();
          }
     },
	//Handle XMLHttpRequest problems, as long as we use one tab to do
	//experiment, the tabURL is valid
     getFirstTabDocument:function() {
          try{
               var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                                        .getService(Components.interfaces.nsIWindowMediator);
               var browserEnumerator = wm.getEnumerator("navigator:browser");

               var browserWin = browserEnumerator.getNext();
               var tabbrowser = browserWin.gBrowser;

               var currentBrowser = tabbrowser.getBrowserAtIndex(0);
//			this.logger.Log("Get First Tab");
			return currentBrowser.contentWindow.document
          }catch(e){
//               this.logger.LogError(e.name);
               return null;
          }
     },
     longestMatch:function(url){
	 var tmp = url.split("//")[1]; 
	 while(!this.isSet(tmp)){
this.logger.Log("tmp: "+tmp);
		 if(tmp.lastIndexOf("/")<0)
			 return null;
		 tmp = tmp.substr(0,tmp.lastIndexOf("/",tmp.length-2)+1);
	 }
	 return tmp;
     },	     
     //bfKey consist of [Origin defined by SOP]-[cookie]
     isSet:function(bfKey){
          if(this.hash[bfKey]==undefined)
               return false
          else
               return true;
     },
     add:function(bfKey,filters){
          this.hash[bfKey] = filters;
     },
     getFilters:function(bfKey){
          if(this.hash[bfKey]==undefined)
               return false
          else
               return this.hash[bfKey];
     },
     setCache:function(){
	this.useCache = this.useCache?false:true;
	document.getElementById("customized-Status").value= this.useCache;

     },
   }
Scope = function(host,path,isDomain){
     this.host = host;
     this.path = path;
     this.isDomain = isDomain;
}
Scope.prototype = {
}
