BloomFilter = function(len){
	this.len = len;
	this.itemCount = 0;
	this.cache = new Object();
	try{
		var arrayLen = len/32;
		this.map = new Array(arrayLen);
		for(var i=0;i<arrayLen;i++) 
			this.map[i] = 0 ; 
	}catch(e){
	}
	this.hashCount = 16;
	this.salt = "";
}
BloomFilter.prototype = {
	ImportBase64: function(mapBase64,salt){
		this.salt = salt;
		var map = Base64.decode(mapBase64);
		this.map = new Array(map.length/4);
		this.len = map.length*8;
		oDerefLogger.Log("Length "+this.len);
		for(var i=0;i < map.length;i+=4){
			var result = 0;
			for(var j = 0;j<3;j++){
				result |= map[i+j];
				result <<= 8;
			}
			result |= map[i+3];
			this.map[parseInt(i/4)] = result;
		}
	},
	ExportBase64: function(){
		var mask = [0xff000000,0xff0000,0xff00,0xff];
		var result = "";
		for(var i=0;i < this.map.length;i++){
			var v = this.map[i];
			result += String.fromCharCode((v & mask[0])>>>24);
			result += String.fromCharCode((v & mask[1])>>>16);
			result += String.fromCharCode((v & mask[2])>>>8);
			result += String.fromCharCode((v & mask[3]));
		}
		return Base64.encode(result);
	},
	setBit: function(bitPos){
		var index = parseInt(bitPos/32);
		var pos = bitPos%32;
		var value = 1;
		value <<= (32-(pos+1));
		this.map[index] |= value
	},
	checkBit: function(bitPos){
		var index = parseInt(bitPos/32);
		var pos = bitPos%32;
		var value = 1;
		value <<= (32-(pos+1));
		var result = this.map[index] & value; 
		return (result == 0)?false:true;
	},
	Add: function(key){
		this.itemCount++;
		var nextSalt = this.salt;
		for(var i =0;i < this.hashCount; i++){
			var pos = this.hash(nextSalt+key);
			this.setBit(pos);
			nextSalt = hex_md5(nextSalt.toString());
		}
	},
	Has: function(key){
/*
		if(this.cache[key] == true){
			oDerefLogger.Log("Cached "+key);
			return true;
		}
*/
			
		var nextSalt = this.salt;
		for(var i =0;i < this.hashCount; i++){
			var pos = this.hash(nextSalt+key);
		//	oDerefLogger.Log(nextSalt+key+" "+pos);
			if(!this.checkBit(pos))
				return false;
			nextSalt = hex_md5(nextSalt.toString());
		}
//		this.cache[key] = true;
		return true;
	},
	hash: function(str){
		var hash = hex_md5(str);
		//oDerefLogger.Log(str+" "+hash);
		var value = parseInt(hash.substr(0,7),16);
		return (value%this.len);
	},
};

